//    
// .9,  "   "
//     -    
//        12 
// ( ,    brute force -   )
//  ""   , 
//    next_permutation()  STL.
// 

#include <iostream>
#include <algorithm>
using namespace std;

#define N 12

    //   -     :
    //   Tmpr[city][month]
    //
double Tmpr[12][12] = {
    {-12.3, -8.4,  -1.9,  5.1,   9.8,  13.6, 17.6, 19.8, 16,   8.9,  -0.9,  -9.1},
    {-6.3,  -6.6,  -0.5,  9.2,   15.9, 21,   23.6, 22.3, 15.6, 8,    0.3,   -4.7},
    {-6.5,  -6.7,  -1,    6.7,   13.2, 17,   19.2, 17,   11.3, 5.6,  -1.2,  -5.2},
    {-10.1, -9.7,  -5.5,  -0.7,  4,    9.2,  12.8, 11.1, 7,    1.5,  -4.8,  -8.2},
    {-8.9,  -8.8,  -2.6,  6.1,   12.9, 17.2, 19.4, 16.9, 11.1, 4.7,  -2.8,  -7.3},
    {-16.5, -14.8, -7.6,  2.3,   11.8, 17.1, 19.4, 16.6, 10.2, 3.1,  -6.9,  -14},
    {-46.4, -42,   -31.2, -13.6, 2.7,  12.6, 14.9, 10.3, 2.3, -14.8, -35.2, -45.5},
    {-10.3, -10,   -7.3,  3.7,   12.5, 18,   19.6, 16.9, 10.4, 3.5,  -7.3,  -10.8},
    {-5.5,  -5.8,  -1.3,  5.1,   11.3, 15.7, 18.8, 16.9, 11.6, 6.2,  0.1,   -3.7},
    { 6.1,  6,     8.2,   12.1,  16,   20.2, 23.2, 23.6, 20,   15.8, 11.1,  8.1},
    {-7.5,  -7.9,  -2.4,  7.5,   14.5, 18.4, 20.4, 18.7, 12.7, 6.1,  -1.4,  -6.3},
    {-6.6,  -7,    -1.6,  8.3,   15.3, 19.4, 21.4, 20.1, 14,   7.1,  -0.3,  -5.3}
};


//===============================
//  NextPermutationNarajana(int* Perm)
//  ""  ( -   )
//   .
// IN:
//   int* Perm  - ,   
// OUT:
//   =True  -
//   =False -
//===============================
bool NextPermutationNarajana(int* Perm) {
    int a=-1, b=-1;

    // search last a: Perm[a]<Perm[a+1]
    for(a=N-2; a>=0; --a)
        if (Perm[a]<Perm[a+1])
            break;
    if (a<0)
        return false;

    // search b>a: Perm[b]>Perm[a]
    for(b=N-1; b>a; --b)
        if (Perm[b]>Perm[a])
            break;
    if (b<=a)
        return false;

    // swap [a] and [b]
    swap(Perm[a], Perm[b]);

    // reverse Perm[a+1..N-1]
    int i=a+1, j=N-1;
    while(i<j) {
        swap(Perm[i], Perm[j]);
        ++i;
        --j;
    }

    return true;
}


//===============================
bool NextPerm(int* Perm) {
    bool res = next_permutation(&Perm[0], &Perm[N]);
    return res;
}


//===============================
double Evaluate(int* Perm) {
    double res = 0;
    for(int i=0; i<N; ++i)
        res += Tmpr[Perm[i]][i];
    return res;
}


//=============================
void PrintRes(int* Perm, double Res) {
    cout <<"[ ";
    for(int i=0; i<N; ++i)
        cout <<1+Perm[i] <<" ";
    cout <<"] = " <<Res <<endl;
}


//===============================
int main() {
    int Curr[12], Best[12];

    // init
    for(int i=0; i<N; ++i)
        Curr[i] = Best[i] = i;

    double CurrRes = Evaluate(Curr),
           BestRes = Evaluate(Best);

    long count = 0;

    do {
        CurrRes = Evaluate(Curr);

        if (BestRes<CurrRes) {
            for(int i=0; i<N; ++i)
                Best[i] =Curr[i];
            BestRes=CurrRes;
            PrintRes(Best, BestRes);
        }

        ++count;
        //if(count%1000000==0) PrintRes(Best, BestRes);

    } while (NextPerm(Curr));

    cout << "Finally (! 1-based indexing !): ";
    PrintRes(Best, BestRes);
}

/*
== Narayana algorithm ==
Finally (! 1-based indexing !): [ 3 4 5 11 6 8 7 2 1 12 9 10 ] = 87
Process returned 0 (0x0)   execution time : 4.686 s

== STL's next_permutation ==
Finally (! 1-based indexing !): [ 3 4 5 11 6 8 7 2 1 12 9 10 ] = 87
Process returned 0 (0x0)   execution time : 4.712 s
*/














